<script lang="ts">
    // This component sets up the overall panel layout of the app
    import { PaneGroup, Pane, PaneResizer } from "paneforge";
    import {
        AdjustmentsHorizontal,
        Bookmark,
        EllipsisVertical,
    } from "svelte-heros-v2";
    import {
        left_pane_api,
        left_pane_collapsed,
    } from "./svelte_stores/show_panes_store.js";
    import {
        innerWidth,
        sidebar_width,
    } from "./svelte_stores/sidebar_width_store";
    import { Tabs, TabItem } from "flowbite-svelte";

    import Navbar from "./Navbar.svelte";
    import LayoutEdit from "./LayoutEdit.svelte";
    import Bookmarks from "./Bookmarks.svelte";
    import ZoomableSVG from "./svg_plots/ZoomableSVG.svelte";

    // Bind to the SVG container size, to prevent rendering the plot when the container is too small
    let svg_container_width = 0;
    let svg_container_height = 0;

    // Test
    let innerHeight;

    const navbarHeight = 54;
    let navbarPaneGroup, mainPaneGroup;
    $: navbarHeightPercent = 100 * (navbarHeight / innerHeight);

    $: if (navbarPaneGroup) {
        navbarPaneGroup.setLayout([
            navbarHeightPercent,
            100 - navbarHeightPercent,
        ]);
    }
</script>

<svelte:window bind:innerHeight bind:innerWidth={$innerWidth} />
<main class="h-full w-full">
    <PaneGroup direction="vertical" bind:paneGroup={navbarPaneGroup}>
        <!-- The pane that contains the navbar -->
        <Pane
            class="bg-sky-300 dark:bg-sky-900"
            defaultSize={navbarHeightPercent}
            maxSize={navbarHeightPercent}
            minSize={navbarHeightPercent}
            collapsedSize={0}
            collapsible={true}>
            <Navbar />
        </Pane>
        <!-- We don't include a resizer here at the moment, which would allow a user to hide the navbar -->
        <Pane>
            <!-- The main pane below the navbar that contains the pane group 
             for the layout controls & bookmarks on the left, as well as the timeline on the right -->
            <PaneGroup
                direction="horizontal"
                class="h-full w-full"
                bind:paneGroup={mainPaneGroup}>
                <!-- The pane that contains the layout controls and bookmarks -->
                <Pane
                    bind:pane={$left_pane_api}
                    collapsedSize={0}
                    defaultSize={0}
                    minSize={10}
                    maxSize={100}
                    collapsible={true}
                    class="bg-slate-50">
                    <div
                        class="h-full min-w-96 overflow-auto dark:bg-black"
                        bind:clientWidth={$sidebar_width}>
                        <Tabs>
                            <TabItem open>
                                <div
                                    slot="title"
                                    class="flex items-center gap-2">
                                    <AdjustmentsHorizontal size="18" />Edit
                                    layout
                                </div>
                                <LayoutEdit />
                            </TabItem>
                            <TabItem>
                                <div
                                    slot="title"
                                    class="flex items-center gap-2">
                                    <Bookmark size="18" />Bookmarks
                                </div>
                                <Bookmarks />
                            </TabItem>
                        </Tabs>
                    </div>
                </Pane>
                <PaneResizer class="relative">
                    <div class="resizer bg-slate-300 dark:bg-slate-600"></div>
                    <div class="resizerwide bg-slate-300 dark:bg-slate-600">
                    </div>
                </PaneResizer>
                <!-- The pane that contains the timeline view -->
                <Pane
                    defaultSize={100}
                    collapsedSize={0}
                    minSize={15}
                    maxSize={100}
                    collapsible={true}
                    class="bg-white h-full w-full">
                    <div
                        class="svg-container w-full h-full bg-white dark:bg-slate-900"
                        bind:clientWidth={svg_container_width}
                        bind:clientHeight={svg_container_height}>
                        <!-- Rendering the ZoomableSVG component in a too small div
                             might lead to the browser crashing especially on small
                              screen devices like smartphones -->
                        {#if svg_container_width > 200 && svg_container_height > 300}
                            <ZoomableSVG />
                        {:else}
                            <div class="flex align-center p-5">
                                <span class="font-thin dark:text-white"
                                    >This plot area is set too small to be able
                                    to render the timeline graphs. Use a larger
                                    browser window size, or set your browser's
                                    zoom level to zoom out, in order to create
                                    sufficient space.</span>
                            </div>
                        {/if}
                    </div>
                </Pane>
                <!-- <PaneResizer
                    class="relative flex w-2 items-center justify-center bg-slate-200 dark:bg-slate-700">
                    <div class="resizerwide"></div>
                    <div
                        class="resizer z-10 flex h-full w-7 items-center justify-center rounded-sm border bg-slate-100 dark:bg-slate-800">
                    </div>
                </PaneResizer>
                <Pane
                    defaultSize={0}
                    class="bg-white h-full w-full"
                    order={3}>
                    <div
                        class="flex h-full w-full items-center justify-center"> -->
                <!-- <ZoomableSVG />
                    </div>
                </Pane> -->
            </PaneGroup>
        </Pane>
    </PaneGroup>
</main>

<style>
    .resizer {
        position: relative;
        z-index: 0;
        width: 2px;
        height: 100%;
        cursor: col-resize;
    }

    .resizer-horizontal {
        position: relative;
        z-index: 0;
        height: 2px;
        width: 100%;
        cursor: row-resize;
    }

    .resizerwide {
        position: absolute;
        left: -10px;
        right: -10px;
        height: 100%;
        top: 0;
        opacity: 0%;
        transition: opacity 0.4s;
        z-index: 1;
        cursor: col-resize;
    }

    .resizerwide-horizontal {
        position: absolute;
        opacity: 0%;
        top: -10px;
        bottom: -10px;
        width: 100%;
        transition: opacity 0.4s;
        z-index: 2;
        cursor: row-resize;
    }

    .resizerwide:hover {
        opacity: 50%;
    }

    .resizerwide-horizontal:hover {
        opacity: 50%;
    }

    .svg-container {
        height: 100%;
        overflow: clip;
    }
</style>
